/*
CSC 130, Spring 2011
Weeek 3 #3

Create a Processing program that keeps track of the last letter you pressed, and
displays it. Make sure you don’t have a bunch of overlapping letters floating
around (hint: use the text() and background() functions appropriately).

Optional: display the last 3 letters you pressed; choose a pair of keys that you
can use to increase/decrease the font size (for extra fun: try to keep the
letter centered on your screen as you change the size – the textWidth() and
textAscent() functions might help); change the color of the background and/or
letter each time you press a new key.

*/

// Last chars pressed (1, 2, and 3 presses ago)
char last1, last2, last3;

// Text size
int size = 50;
// Step size for increasing/decreasing text size
int sizeInc = 5;

// Initial program setup
void setup() {
    size(400, 200);
    // Set text alignment option so that text is centered in rectangle
    // textAlign(CENTER, CENTER);
    last1 = ' ';
    last2 = ' ';
    last3 = ' ';
}

// Function called to draw each frame
void draw() {
    // Redraw background to clear last frame
    background(255);

    // Set color and size for text
    fill(0);
    textSize(size);
    
    // Concatenate last 3 letters; note that without starting with an 
    // empty string, char variables are added like integers
    String letters = "" + last3 + last2 + last1;
    // Draw letters, computing offset to keep letters centered
    int lettersX = width/2 - (int)(textWidth(letters) / 2);
    int lettersY = height/2 + (int)(textAscent() / 2);
    text(letters, lettersX, lettersY);
}

// Function called each time key is pressed
void keyPressed() {
    // Do not do anything if special keys (shift, alt, etc.) are pressed
    if (key == CODED)
        return;

    // Otherwise, take action based on key pressed
    switch(key) {
    // If + or - are pressed, update text size
    case '-':
        size = size - sizeInc;
        break;
    case '+':
        size = size + sizeInc;
        break;
    // Otherwise, track last key press
    default:
        // Shift variables: new 3rd from last is old 2nd from last, etc.
        last3 = last2;
        last2 = last1;
        last1 = key;
        break;
    }
}
