/*
CSC 130, Spring 2011
Weeek 5 part 2 #2

Write a Processing program that implements the following game: when starting the
program, a circle is drawn in a random location. When you click on the circle,
it disappears, and a new circle is drawn in another random location. The game
lasts until you click 10 circles, and your final score is the time it took you
to finish.

Optional: display the elapsed time; have the circles move around; have the
circles move around in a way that tries to avoid the mouse pointer; get creative
with the type of target you’re using. The millis() function is useful for
measuring elapsed time.

*/

// Track number of circles clicked
int hits = 0;
// Indicate if game is over
boolean gameOver = false;
// Location of current circle
float circleX;
float circleY;
// Start and end times, in ms.
float startTime, endTime;

// Diameter of target circles
final float DIAM = 50;
// Number of circles clicked to win
final int GOAL = 2;

void setup() {
    size(500, 500);
    fill(0);
    // Set initial circle position
    circleX = random(DIAM/2, width - DIAM/2);
    circleY = random(DIAM/2, height - DIAM/2);
    // Track starting time
    startTime = millis();
}
    
void draw() {
    // Clear screen
    background(255);
    // If game is over, print score and return from function
    if (gameOver) {
        String message = "Your time was " + endTime/1000 + " seconds.";
        text(message, width/2 - textWidth(message)/2, height/2);
        return;
    }
    // Draw target circle
    ellipse(circleX, circleY, DIAM, DIAM);
}

void mouseClicked() {
    // Return from function (don't do anything) if game is over
    if (gameOver) {
        return;
    }
    // Determine if click was inside target by using the equation for a circle
    // centered at (circleX, circleY).
    float dx = mouseX - circleX;
    float dy = mouseY - circleY;
    float r = DIAM/2;
    if (dx * dx + dy * dy <= r * r) {
        // Increment hits and determine if game is over
        hits = hits + 1;
        gameOver = hits == GOAL;
        if (gameOver) {
            // Keep track of ending time
            endTime = millis();
        } else {
            // If game is not over, pick a new location for the target
            circleX = random(DIAM/2, width - DIAM/2);
            circleY = random(DIAM/2, height - DIAM/2);
        }
    }
}
