/*
CSC 130, Spring 2011
Weeek 5 part 2 #3

Write a Processing program that draws a checkerboard pattern. Define constants
ROWS and COLS to determine the number of rows and columns of squares. Make sure
that your program still works if you change the number of rows and columns.

Optional: draw a circle in a square (like you’re placing a checker piece) when
you click on it.

*/

final int ROWS = 8;
final int COLS = 8;

float squareWidth;
float squareHeight;

void setup() {
    size(500, 500);
    squareWidth = (float)width / COLS;
    squareHeight = (float)height / ROWS;
    for (int row = 0; row < ROWS; ++row) {
        for (int col = 0; col < COLS; ++col) {
            // Trick for getting alternating colors: when sum of row and column
            // number is odd, use first color, otherwise use a second.
            boolean sumEven = (row + col) % 2 == 0;
            if (sumEven) {
                fill(0);
            } else {
                fill(255);
            }
            // Draw a rectangle with calculated width, at correct row and column position:
            rect(row * squareWidth, col * squareHeight, 
                 squareWidth, squareHeight);
        }
    }
}

// Optional part: draw a circle centered on the square you click in
void mouseClicked() {
    // Calculate clicked square by dividing mouse position by width
    int row = floor(mouseX / squareWidth);
    int col = floor(mouseY / squareHeight);
    // Calculate center by multiplying row/col number (with an addition 0.5 to
    // get the center of square).
    float centerX = squareWidth * (row + 0.5);
    float centerY = squareHeight * (col + 0.5);

    ellipse(centerX, centerY, squareWidth, squareHeight);
}

void draw() {}
